package com.key.vibekeyboard.Adapter;

import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.resource.bitmap.CenterCrop;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;
import com.bumptech.glide.request.RequestOptions;
import com.key.vibekeyboard.Activity.DownloadActivity;
import com.key.vibekeyboard.Activity.SearchActivity;
import com.key.vibekeyboard.R;
import com.key.vibekeyboard.Room.WallpaperInfo;

import java.util.ArrayList;
import java.util.List;

public class SearchRecyclerViewAdapter extends RecyclerView.Adapter<SearchRecyclerViewAdapter.ViewHolder> {

    private List<WallpaperInfo> wallpaperList;
    private SearchActivity context;

    public SearchRecyclerViewAdapter(List<WallpaperInfo> wallpaperList, SearchActivity context) {
        this.wallpaperList = wallpaperList;
        this.context = context;
    }

    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.home_recycler_item, parent, false);
        return new ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, int position) {
        WallpaperInfo wallpaperInfo = wallpaperList.get(position);

        List<WallpaperInfo> limitedList = wallpaperList.subList(0, Math.min(20, wallpaperList.size()));

        holder.imageView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(context, DownloadActivity.class);
                intent.putExtra("wallpaperInfo", wallpaperInfo); // wallpaperInfo 已经实现了 Parcelable
                intent.putParcelableArrayListExtra("list", new ArrayList<>(limitedList)); // list 中的 WallpaperInfo 对象实现了 Parcelable
                context.startActivity(intent);
            }
        });
// 应用圆角变换
        RequestOptions options = new RequestOptions()
                .placeholder(R.mipmap.splash)
                .error(R.mipmap.splash)
                .transform(new CenterCrop())
                .transform(new RoundedCorners(16)); // 设置圆角度数

        Glide.with(context)
                .load(wallpaperInfo.getPreview())
                .apply(options)
                .into(holder.imageView);
        // 根据需要加载其他字段，如图片等
    }

    @Override
    public int getItemCount() {
        return wallpaperList.size();
    }

    public static class ViewHolder extends RecyclerView.ViewHolder {

        private ImageView imageView;

        public ViewHolder(@NonNull View itemView) {
            super(itemView);
            imageView = itemView.findViewById(R.id.home_recycler_image);
        }
    }
}

